// -*- C++ -*-
/*!
 * @file  SHMclient.cpp
 * @brief SharedMemoryComponentServer
 * $Date$
 *
 * $Id$
 */

#include "SHMclient.h"

// Module specification
// <rtc-template block="module_spec">
static const char* shmclient_spec[] =
  {
    "implementation_id", "SHMclientRW",
    "type_name",         "SHMclientRW",
    "description",       "SharedMemoryComponentServer",
    "version",           "3.0",
    "vendor",            "Takasi Kojima,klab",
    "category",          "database",
    "activity_type",     "",
    "max_instance",      "10",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

SHMclient::SHMclient(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_updateIn("update", m_update),
    m_requestIDServicePort("requestIDService"),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  registerOutPort("update", m_updateIn);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  m_requestIDServicePort.registerConsumer("requestID", "requestID", m_requestID);
  
  // Set CORBA Service Ports
  registerPort(m_requestIDServicePort);
  
  // </rtc-template>

}

SHMclient::~SHMclient()
{
}


RTC::ReturnCode_t SHMclient::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  
  // </rtc-template>
  return RTC::RTC_OK;
}



/*
RTC::ReturnCode_t SHMclient::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SHMclient::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SHMclient::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SHMclient::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t SHMclient::onDeactivated(RTC::UniqueId ec_id)
{
	try{
		//L폜
		if(m_requestID->getRequestFlag()==3)
		{
			m_requestID->request(-1,sizeof(test_structure),"test_structure"); //tO͎ŃZbg
//			m_requestID->request(-1,sizeof(test_structure),"test_strucure!!"); //tO͎ŃZbgič폜ȂeXgpj

			while(m_requestID->getRequestFlag()==1 );
#ifdef DEBUG_PRINT
			std::cout << __FUNCTION__ <<"get ID -> Shared memory ID : " <<m_requestID->getShmID() << ", semaphore ID : " << m_requestID->getSemID() << std::endl;
#endif
			m_requestID->setRequestFlag(0);//tO
		}
	}
	catch(...){}
  return RTC::RTC_OK;
}



RTC::ReturnCode_t SHMclient::onExecute(RTC::UniqueId ec_id)
{
	long semID(-1);
	try{
		if(m_requestID->getRequestFlag()==0)
		{
			m_requestID->request(1,sizeof(test_structure),"test_structure"); //tO͎ŃZbg
		}
		if(m_requestID->getRequestFlag()==2)
		{
			std::cout << "get ID -> Shared memory ID : " <<m_requestID->getShmID() << ", semaphore ID : " << m_requestID->getSemID() << std::endl;
			m_requestID->setRequestFlag(3);//ItOZbg
		}
		if(	m_requestID->getShmID() > 0 )shmptr = shmClient.returnPointer(m_requestID->getShmID() );
		else sleep(1);
		if(shmptr != NULL){
			semID = m_requestID->getSemID();
			shmClient.lock(semID);
			shmptr->command += 1;
			for(int i(0);i<6;i++)shmptr->angle[i] = (double)(i+1);
			sleep(1);
			shmClient.unlock(semID);
			m_update.byte = sizeof(test_structure);
			m_update.explain = "test_structure";
			m_updateIn.write();
			sleep(1);
			shmClient.lock(semID);
			std::cout << "command : " << shmptr->command << std::endl;
			for(int i(0);i<6;i++) {
				std::cout << "angle[" << i << "]  = " << shmptr->angle[i] ;
if(!(i%2))std::cout << "\t" ;
 else std::cout <<  "\n" ;
}
			std::cout << std::endl;
			shmClient.unlock(semID);
			sleep(2);
		}
	}
	catch(...){

	}
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t SHMclient::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SHMclient::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SHMclient::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SHMclient::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t SHMclient::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void SHMclientInit(RTC::Manager* manager)
  {
    RTC::Properties profile(shmclient_spec);
    manager->registerFactory(profile,
                             RTC::Create<SHMclient>,
                             RTC::Delete<SHMclient>);
  }
  
};


