// -*-C++-*-
/*!
 * @file  connectorSHMSVC_impl.cpp
 * @brief Service implementation code of connectorSHM.idl
 *
 */

#include "connectorSHMSVC_impl.h"

/*
 * Example implementational code for IDL interface requestID
 */
requestIDSVC_impl::requestIDSVC_impl()
:requestFlag(0),myShmID(-1),mySemID(-1),req_control(0)
{
  // Please add extra constructor code here.
}

requestIDSVC_impl::~requestIDSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
void requestIDSVC_impl::request(CORBA::Short control, CORBA::Long byte, const char* explain)
{
	requestFlag = 1;
	req_control = control;
	req_explain = explain;
	req_byte    = (long)byte;
}

CORBA::Long requestIDSVC_impl::getShmID()
{
	return (CORBA::Long)myShmID;
}

CORBA::Long requestIDSVC_impl::getSemID()
{
	return (CORBA::Long)mySemID;
}

char* requestIDSVC_impl::getExplain()
{
	return CORBA::string_dup(req_explain.c_str());
}

CORBA::Long requestIDSVC_impl::getByte()
{
	return (CORBA::Long)req_byte;
}

CORBA::Short requestIDSVC_impl::getControl()
{
	return (CORBA::Short)req_control;
}

CORBA::Short requestIDSVC_impl::getRequestFlag()
{
	return (CORBA::Short)requestFlag;
}

void requestIDSVC_impl::setIDs(CORBA::Long shmID, CORBA::Long semID)
{
	requestFlag = 2;
	myShmID = (long)shmID;
	mySemID = (long)semID;
}

void requestIDSVC_impl::setRequestFlag(CORBA::Short condition)
{
	requestFlag = (short)condition;
}

// End of example implementational code



