#!/bin/sh

###### Setting omniORB ################

nsport='9876'
hostname=`hostname`

##### Setting Module Profile ###########

# Name
MODULE_NAME="SHMserver"

# Version
VERSION="3.0"

# Group(make virtual module folder)
CATEGORY='database'

# component type STATIC,UNIQUE,COMMUTATIVE
#	STATIC      :Œ
#	UNIQUE      :ĹAӓI
#	COMMUTATIVE :́A
COMPONET_TYPE=STATIC

# activity type DataFlowComponent,PERIODIC,SPORADIC,EVENT_DRIVEN
#	DataFlowComponet  :
#	PERIODIC          :I
#	SPORADIC          :˔I
#	EVENT_DRIVEN      :CxgH

ACTIVITY_TYPE=SPORADIC

# module maximum instance()
MAXIMAM_INSTANCE=10

######## Inistalize #########


rm -f ./*~
rm -rf ./*.o
rm -rf ./*.c*
rm -rf ./*.h*
rm -rf ./*.log
rm -rf ./*.$MODULE_NAME
echo -e "\033[32mInisialize......Finish\033[0m"

########## Make rtc.conf ############

echo 'corba.nameservers: '$hostname':'$nsport > ./rtc.conf
echo 'naming.formats: '$CATEGORY'/%n.rtc' >> ./rtc.conf
echo 'logger.enablel: NO' >> ./rtc.conf
echo 'logger.log_level: TRACE' >> ./rtc.conf
echo -e "\033[32mMaking rtc.conf......Finish\033[0m"

########## Make Module ############
rtc-template -bcxx \
    --module-name=$MODULE_NAME \
    --module-type=$MODULE_TYPE \
    --module-desc='SharedMemoryServerComponent' \
    --module-version=$VERSION \
    --module-vendor='Takasi Kojima,klab' \
    --module-category=$CATEGORY \
    --module-comp-type=$COMPONENT_TYPE \
    --module-act-type=$ACTIVITY_TYPE \
    --module-max-inst=$MAXIMAM_INSTANCE \
    --service=provideID:requestIDs:requestID \
		--inport=synchronizeInport:synchronize_database_connector   --outport=synchronizeOutport:synchronize_database_connector \
		--inport=update:update_inform_connector 		         \
    --consumer-idl=connectorSHM.idl \
    --service-idl=connectorSHM.idl \
		;

echo -e "\033[32mMake clean all...\033[0m"
make -f Makefile.$MODULE_NAME all clean;
echo -e "\033[32m...Finish\033[0m"
