#include "sharedMemoryManager.h"
//============= sharedMemory class ===============//
sharedMemoryInfo::sharedMemoryInfo()
{
	memSize     = 0;
	SHMID       = 0;
	SEMID       = 0;
	KEY         = 0;
	explainRoll = "";
	cnt         = 0;
}
sharedMemoryInfo::sharedMemoryInfo(const sharedMemoryInfo &source)
{
	memSize = source.memSize;
	SHMID      = source.SHMID;
	SEMID      = source.SEMID;
	KEY     = source.KEY;
	explainRoll = source.explainRoll;
	cnt     = source.cnt;
}
sharedMemoryInfo::~sharedMemoryInfo()
{

}
//=============shared memory manager class=================//

sharedMemoryManager::sharedMemoryManager():shmdir("./shmFiles/")
{
	
}
sharedMemoryManager::sharedMemoryManager(const sharedMemoryManager &src):shmdir("./shmFiles/")
{

}

sharedMemoryManager::~sharedMemoryManager()
{
	eraseAll();
	outputList(stderr);
}

//--------add(memorySize, *explain)------------------------------
// :L쐬iłɑ݂ꍇ̓JEgAbvj
// :
//    memorySize :L̎gpTCY( byte)
//    *explain   :L̎gppr()
//
// [ex] add( sizeof(double), "StockValue")
// [ex] add( 8, "StockValue")
//---------------------------------------------------------------
int sharedMemoryManager::add(int memorySize, const char *explain)
{
	FILE *fp;
	string expRoll(shmdir),file;
	list<sharedMemoryInfo>::iterator itr;
	expRoll += explain;
	sharedMemoryInfo tmp;

	// shared memory ݂邩̊mF
	for(itr=shmStocker.begin();itr!=shmStocker.end();++itr)
	{
		if(itr->explainRoll == expRoll && itr->memSize == memorySize)
		{
			(itr->cnt)++;
			if(itr->cnt<0)std::cout << "Error : Attach counter is red!!" <<std::endl;
			return 0;//itr->SHMID;//shared memory̂ŏ̏I
		}
	}

	// shared memoryXgɓo^ĂȂ̂ō쐬
	file = "mkdir -p ";	file += expRoll.substr(0,expRoll.rfind("/"));	system(file.c_str());
	file = "touch ";	  file += expRoll;	system(file.c_str());
	// shared memory, semaphore ʂ̌쐬
	tmp.KEY = ftok(expRoll.c_str(),memorySize);
	if(tmp.KEY==-1){
		std::cout << "Error : ftok() is fault in" << __FILE__ << std::endl;
		return (-1);
	}

	//semaphore 쐬E
	const int semaphoreSize = 1;
	if((tmp.SEMID = makeSemaphore(tmp.KEY, semaphoreSize)) < 0 ) return -1; // 1 ̓Z}tḦ搔(~Ƃ͕ύXׂ)

	//share memory쐬
	if((tmp.SHMID = makeSharedMemory(tmp.KEY, memorySize)) < 0 ) return -1;
	
	// Each parameter setting
	tmp.cnt++;
	tmp.memSize = memorySize;
	tmp.explainRoll = expRoll.c_str();
	shmStocker.push_back(tmp);

	// exit(1)Ȃǂɂ폜Rp̃VF쐬
	file = shmdir;
	file += "removeSHM&SEM.sh";
	if((fp = fopen(file.c_str(),"w")) == NULL ){
		std::cout << "Error : fopen " << file << "in " << __FUNCTION__ << std::endl;
		return tmp.SHMID;
	}
	for(itr=shmStocker.begin();itr!=shmStocker.end();++itr)	//shared memory̐ǋL
	{
		fprintf(fp,"ipcrm -m %d\n",itr->SHMID); //shared memory
		fprintf(fp,"ipcrm -s %d\n",itr->SEMID); //semaphore
	}
	fclose(fp);
	return tmp.SHMID;
}
//shared memorỹJEg if(==0)폜
int sharedMemoryManager::erase(int memorySize, const char *explain)
{
	string expRoll(shmdir),path;
	expRoll += explain;
	list<sharedMemoryInfo>::iterator itr;
	//shared memory݂邩̒T
	for(itr=shmStocker.begin();itr!=shmStocker.end();)
	{
		if(itr->explainRoll == expRoll && memorySize == itr->memSize )
		{
			if(itr->cnt>1)(itr->cnt)--;
			else
			{
				if(itr->cnt<1) std::cout << "Error : Detach counter < 0 " <<std::endl;
				//semaphore̊J
				semctl(itr->SEMID, 0, IPC_RMID, semunion);
				//shared memoryJ
				shmctl(itr->SHMID, IPC_RMID, 0);
				//list̍폜
				shmStocker.erase(itr);
				return 1;
			}
			return 0;//shared memory̂ŏ̏I
		}
		else ++itr;
	}
	std::cout << "Error : Unable " << __FUNCTION__ << " :cannot find "  <<  explain  << std::endl;
	return -1;
}

//semaphoreIDԂ
int sharedMemoryManager::returnSemID(int memorySize, const char *explain, int print)
{
	string expRoll(shmdir),path;
	expRoll += explain;
	list<sharedMemoryInfo>::iterator itr;
	//shared memory݂邩̒T
	for(itr=shmStocker.begin();itr!=shmStocker.end();)
	{
		if(itr->explainRoll == expRoll){
			return itr->SEMID;
		}
		else ++itr;
	}
	if(print)std::cout << "In" << __FUNCTION__ << " Cannot find "  <<  explain  << std::endl;
	return -1;
}

//semaphoreIDԂ
int sharedMemoryManager::returnShmID(int memorySize, const char *explain,int print)
{
	string expRoll(shmdir),path;
	expRoll += explain;
	list<sharedMemoryInfo>::iterator itr;
	//shared memory݂邩̒T
	for(itr=shmStocker.begin();itr!=shmStocker.end();)
	{
		if(itr->explainRoll == expRoll)
		{
			return itr->SHMID;
		}
		else ++itr;
	}
	if(print)std::cout << "In" << __FUNCTION__ << " Cannot find "  <<  explain  << std::endl;
	return -1;
}

int sharedMemoryManager::eraseAll()
{
	int number = shmStocker.size();
	string path,command;	//shared memoryׂĊJďI
	list<sharedMemoryInfo>::iterator itr;	//shared memory݂邩̒T
	itr=shmStocker.begin();
	while(itr!=shmStocker.end())
	{
		path = itr->explainRoll;
		std::cout << "Erase : "<< itr->memSize<< " byte\t" 
		 << itr->explainRoll.substr(shmdir.size()).c_str() << std::endl;
		shmctl(itr->SHMID, IPC_RMID, 0);           //shared memoryJ
		semctl(itr->SEMID, 0, IPC_RMID, semunion); //semaphore̊J
		shmStocker.erase(itr++);        //list̍폜[`
	}
	command  = "rm -rf ";
	command += shmdir;
	system(command.c_str()); //n(ꎞt@C̍폜)
	return number;
}

void sharedMemoryManager::outputList(FILE *fp){
	int i=1;
	//shared memoryׂĊJďI
	list<sharedMemoryInfo>::iterator itr;
	//shared memory݂邩̒T
	itr=shmStocker.begin();
	while(itr!=shmStocker.end())
	{
		fprintf(fp,"<%d> SHM_ID[%d] SEM_ID[%d] Size[%d byte] Roll[%s] Attaching[%d]\n"
			,i++,itr->SHMID,itr->SEMID,itr->memSize,itr->explainRoll.substr(shmdir.size()).c_str(),itr->cnt);
		++itr;
	}
}
void sharedMemoryManager::display()
{
	outputList(stdout);
}

void sharedMemoryManager::write(int memSize, const char *explain)
{
	string expRoll(shmdir),path;
	char buf[20];
	expRoll += explain;
	list<sharedMemoryInfo>::iterator itr;
	//shared memory݂邩̒T
	for(itr=shmStocker.begin();itr!=shmStocker.end();)
	{
		if(itr->explainRoll == expRoll)
		{
			FILE *fp;
			expRoll = "./";
			expRoll += explain;
			sprintf(buf,"%d",memSize);
			expRoll += (const char*)buf;
			expRoll += ".txt";
			if((fp = fopen(expRoll.c_str(),"w"))==NULL)
			{
				std::cout << "Error : fopen "<< expRoll << std::endl;
				return;
			}
			fprintf(fp,"# sharedmemoryID\tsemaphoreID #\n");
			fprintf(fp,"%d\t%d\t%d\t%s\n",itr->SHMID,itr->SEMID,itr->memSize,itr->explainRoll.c_str());
			fclose(fp);
			return;//shared memory̂ŏ̏I
		}
		else ++itr;
	}
	std::cout << "Error : Cannot " << __FUNCTION__ << " :cannot find "  <<  explain  << std::endl;
}
//݂鋤L̏t@C̏o(txt) // dir + filename ver.
void sharedMemoryManager::write(const char* dir, const char* filename)
{
	string path(dir);
	if(path[path.size()-1]!='/')path += "/";
	path += filename;
	write(path.c_str());
}
//݂鋤L̏t@Cɏo(txt) // Union path and filename ver.
void sharedMemoryManager::write(const char* filepathAndName)
{
	FILE *fp;
	int number = shmStocker.size();
	list<sharedMemoryInfo>::iterator itr;	//shared memory݂邩̒T
	itr=shmStocker.begin();
	fp = fopen(filepathAndName,"w");
	if(fp == NULL){
		std::cout << "Error : fopen, cannot open" << std::endl;
		return ;
	}
	fprintf(fp,"# sharedmemory id\tsemaphore id\tsize\tRoll #\n");
	while(itr!=shmStocker.end())
	{
		fprintf(fp,"%d\t%d\t%d\t%s\n",itr->SHMID,itr->SEMID,itr->memSize,itr->explainRoll.c_str());
	}
	fclose(fp);
	return ;
}

//----- protected shared memory manager ------//
int sharedMemoryManager::makeSharedMemory(int key, int memorySize)
{
	int sharedMemoryID;
	//sharedmemory 쐬
	sharedMemoryID  = shmget(key, sizeof(char)*memorySize, IPC_CREAT|0666);
	if(sharedMemoryID < 0)
	{
		std::cout << "Error : shmget() is fault in " << __FILE__ 
			<< "[ key"<< (int)key <<" id=" << sharedMemoryID << " ]" << std::endl;
		return -1;
	}
	return sharedMemoryID;
}

int sharedMemoryManager::makeSemaphore(int key, int semaphoreSize)
{
	int semaphoreID;
	//semaphore 쐬
	semaphoreID = semget(key, semaphoreSize, IPC_CREAT|0666);
	if(semaphoreID < 0)
	{
		std::cout << "Error : semget() is fault in " << __FILE__ 
			<< "[ key"<< (int)key <<" id=" << semaphoreID << " ]" << std::endl;
		return -1;
	}
	//semphore 
  semunion.val = 1;
	if(semctl(semaphoreID, 0, SETVAL, semunion) == -1){
    std::cout << "Error : semctl(init) failure in " << __FILE__  << std::endl;
    return -1;
  }	
	return semaphoreID;
}

