#ifndef _SHARED_MEMORY_MANAGER_
#define _SHARED_MEMORY_MANAGER_

#include <string>
#include <iostream>
#include <list>
#include <cstdlib>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>

using namespace std;



class sharedMemoryInfo{
 public:
	sharedMemoryInfo();
	sharedMemoryInfo(const sharedMemoryInfo &source);
	~sharedMemoryInfo();
	//---- memory size,id,key
	int memSize, SEMID,SHMID;  key_t KEY;
	//---- roll
	string explainRoll;
	//---- attaching counter
	int cnt;
};

#ifndef _SEM_UNION_STRUCT_	//Z}tHp̂錾ĂȂꍇ
union semunion_struct {
  int val;                  // SETVAL ̒l 
  struct semid_ds *buf;     // IPC_STAT, IPC_SET p̃obt@ 
  unsigned short *array;    // GETALL, SETALL p̔z 
  // Linux L̕: 
  struct seminfo *__buf;    // IPC_INFO p̃obt@ 
};
#endif

//shared memoryǗNX
class sharedMemoryManager
{
	protected:
		semunion_struct semunion; //Z}tH쐬A폜ɕKvȋp
		const string shmdir;//shared memory ꎞt@C쐬fBNg
		list<sharedMemoryInfo> shmStocker; // shared memory stocker

		inline int makeSemaphore(int key,int semaphoreSize); //inlineɂAZuWJ()
		inline int makeSharedMemory(int key,int semaphoreSize);

	public:
		// consructor,destructor
		sharedMemoryManager();
		sharedMemoryManager(const sharedMemoryManager &src);
		virtual ~sharedMemoryManager();

		// shared memoryJEg if(==0)쐬
		int add(int memorySize, const char *explanation);

		// shared memorỹJEg if(==0)폜
		int erase(int memorySize, const char *explain);

		// shemaphoreIDԂ
		int returnSemID(int memorySize, const char *explain,int print=0);

		// shared memoryIDԂ
		int returnShmID(int memorySize, const char *explain,int print=0);


		//IɑSshared memory폜
		int eraseAll();
		
		// o͐w肵 Shared memory list\
		void outputList(FILE *fp);

		// ^[~iɏ\
		void display();

		// LAZ}tHPo(id̂)(txt)
		void write(int memSize, const char *explain);
		
		// LAZ}tH܂Ƃ߂ďo(txt)
		void write(const char* filepathAndName);
		void write(const char* path, const char* filename);

};
#endif

