// -*- C++ -*-
/*!
 * @file  H8_communication_GUI.cpp
 * @brief H8_communication_GUI
 * $Date$
 *
 * $Id$
 */

#include "H8_communication_GUI.h"

// Module specification
// <rtc-template block="module_spec">
static const char* h8_communication_gui_spec[] =
  {
    "implementation_id", "H8_communication_GUI",
    "type_name",         "H8_communication_GUI",
    "description",       "H8_communication_GUI",
    "version",           "2.0",
    "vendor",            "Takasi Kojima,klab",
    "category",          "CommunicationH8",
    "activity_type",     "",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

H8_communication_GUI::H8_communication_GUI(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_H8RcvDataInfomerIn("H8RcvDataInfomer", m_H8RcvDataInfomer),
    m_H8SndDataInfomerOut("H8SndDataInfomer", m_H8SndDataInfomer),
    m_requestReceiveIDPort("requestReceiveID"),
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("H8RcvDataInfomer", m_H8RcvDataInfomerIn);
  
  // Set OutPort buffer
  registerOutPort("H8SndDataInfomer", m_H8SndDataInfomerOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  m_requestReceiveIDPort.registerConsumer("requestID", "requestID", m_requestID);
  
  // Set CORBA Service Ports
  registerPort(m_requestReceiveIDPort);
  
  // </rtc-template>

}

H8_communication_GUI::~H8_communication_GUI()
{
}


RTC::ReturnCode_t H8_communication_GUI::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  
  // </rtc-template>
  return RTC::RTC_OK;
}




RTC::ReturnCode_t H8_communication_GUI::onFinalize()
{
	gui.end();
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t H8_communication_GUI::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t H8_communication_GUI::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t H8_communication_GUI::onActivated(RTC::UniqueId ec_id)
{
	int flag(1);
	gui.setReceiveSHM_ID(-1);
	gui.setReceiveSEM_ID(-1);
	gui.setSendSHM_ID(-1);
	gui.setSendSEM_ID(-1);
	while(flag){
		try{
			if(m_requestID->getRequestFlag()==0){
				m_requestID->request(1,sizeof(receive_data_struct),"H8ComReceiveData");
				while(m_requestID->getRequestFlag()<2)usleep(1);
				gui.setReceiveSHM_ID(m_requestID->getShmID());
				gui.setReceiveSEM_ID(m_requestID->getSemID());
				m_requestID->setRequestFlag(5);
			}
			if(m_requestID->getRequestFlag()==5)
			{
				m_requestID->request(1,sizeof(send_data_struct),"H8ComSendData");
				while(m_requestID->getRequestFlag()<2)usleep(1);
				gui.setSendSHM_ID(m_requestID->getShmID());
				gui.setSendSEM_ID(m_requestID->getSemID());
				m_requestID->setRequestFlag(3);
			}
			flag = 0;
		}
		catch(...)
		{

		}
	}
	gui.start();
  return RTC::RTC_OK;
}



RTC::ReturnCode_t H8_communication_GUI::onDeactivated(RTC::UniqueId ec_id)
{
	int flag(1);
	gui.setReceiveSHM_ID(-1);
	gui.setReceiveSEM_ID(-1);
	gui.setSendSHM_ID(-1);
	gui.setSendSEM_ID(-1);
	gui.end();
	try{
		if(m_requestID->getRequestFlag()==0)flag=0;
	}
	catch(...)
	{

	}
	while(flag){
		try{
			if(m_requestID->getRequestFlag()==3)
			{
				m_requestID->request(-1,sizeof(receive_data_struct),"H8ComReceiveData");
				while(m_requestID->getRequestFlag()<2)usleep(1);
				m_requestID->setRequestFlag(5);
			}
			if(m_requestID->getRequestFlag()==5)
			{
				m_requestID->request(-1,sizeof(send_data_struct),"H8ComSendData");
				while(m_requestID->getRequestFlag()<2)usleep(1);
				m_requestID->setRequestFlag(0);
			}
			flag = 0;
		}
		catch(...)
		{

		}
	}
  return RTC::RTC_OK;
}



RTC::ReturnCode_t H8_communication_GUI::onExecute(RTC::UniqueId ec_id)
{



	//GUIɂ鑗M{^ꂽꍇ
	if(gui.dialog == NULL)std::cout<< "dialog address is NULL" << std::endl;
	else if((gui.dialog)->sendflag)
	{
		//flag̏
		(gui.dialog)->sendflag = 0;
		//f[^ZbgM
		m_H8SndDataInfomer.explain = "H8ComSendData";
		m_H8SndDataInfomer.byte = sizeof(send_data_struct);
		m_H8SndDataInfomerOut.write();
	
		std::cout << "<---- Write Shared memory  -----" << std::endl;
	}
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t H8_communication_GUI::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t H8_communication_GUI::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t H8_communication_GUI::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t H8_communication_GUI::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t H8_communication_GUI::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void H8_communication_GUIInit(RTC::Manager* manager)
  {
    RTC::Properties profile(h8_communication_gui_spec);
    manager->registerFactory(profile,
                             RTC::Create<H8_communication_GUI>,
                             RTC::Delete<H8_communication_GUI>);
  }
  
};


