/*************************************************************/
/*                                                           */
/*  Class : FormH8GUI                                        */
/*                                                           */
/*  Author : T.Kojima                                        */
/*                                                           */
/*  Date   : 20071203                                        */
/*                                                           */
/*  Comment:                                                 */
/*                                                           */
/**************************************************************/

#ifndef FLOATSPINBOX_H
#define FLOATSPINBOX_H

#include <qspinbox.h>
#include <qvalidator.h>

class FloatSpinBox : public QSpinBox
{
  Q_OBJECT
 public:
  FloatSpinBox( QWidget* parent = 0, const char* name = 0 ,int decimals = 2);
  FloatSpinBox( float minValue, float maxValue, int decimals = 2, float step = 1.0, 
		QWidget* parent = 0, const char* name = 0 );
  ~FloatSpinBox();

  virtual QSize sizeHint () const;

  float value() const;
  float minValue() const;
  float maxValue() const;

  void setRange( float minValue, float maxValue );

 public slots:
  void setValue( float value );
	void setAbsoluteMaxValue(float maxValue);
	void setAbsoluteMinValue(float minValue);

 signals:
  void valueChanged( float value );

 protected:
  virtual QString mapValueToText ( int value );
  virtual int mapTextToValue ( bool * ok = 0 );
  virtual void valueChange ();

 private:
  QDoubleValidator* dVal;

  int dec;
};

#endif


