#ifndef _SHARED_MEMORY_CLIENT_
#define _SHARED_MEMORY_CLIENT_

#include <string>
//stringstreamp
#include <sstream>
#include <iostream>
#include <list>
#include <cstdlib>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>

//semtimedopp
#include <time.h>

using std::string;
using std::stringstream;

#ifndef _SEM_UNION_STRUCT_	//Z}tHp̂錾ĂȂꍇ
union sem_uni_struct
{
	// SETVAL ̒l 
  int val;
	// IPC_STAT, IPC_SET p̃obt@ 
	struct semid_ds *buf;
	// GETALL, SETALL p̔z
	unsigned short *array;
	// Linux L̕: IPC_INFO p̃obt@
	struct seminfo *__buf;
};
#endif

template <typename SHARED_MEMORY_STRUCT= void>
class sharedMemoryClient
{
 protected:
	struct sembuf sembuffer;//Z}tH̃Zbgpϐ
	union sem_uni_struct semunion;
	//pointer
	SHARED_MEMORY_STRUCT *sharedMemoryPointer;

 public:
	const int semaphoreID , sharedMemoryID;
	sharedMemoryClient():semaphoreID(-1),sharedMemoryID(-1){sharedMemoryPointer=NULL;sembuffer.sem_flg=SEM_UNDO;};
	~sharedMemoryClient(){sharedMemoryPointer=NULL;};

	int read(const char *dir, const char *filename)
	{
		string path(dir);
		if(path[path.size()-1]!='/')path += "/";
		path += filename;
		return read(path.c_str());
	};
	int read(const char *pathAndFilename)
	{
		FILE *fp;
		char buffer[255];
		fp = fopen(pathAndFilename,"r");
		if(fp == NULL){
			std::cout << "Error : Cannot open " << pathAndFilename << std::endl;
			return -1;
		}
		fgets(buffer,255,fp);//Psڂ͓ǂݔ΂
		fscanf(fp,"%d%c%d",&sharedMemoryID,&buffer[0],&semaphoreID); //KvȂ̂͂
		fclose(fp);
		return 0;
	};
	int semaphoreCheck(int sem_id )
	{
		int ret;
		ret = semctl(sem_id,0,GETVAL,semunion);//l擾
		return ( ret < 0 ) ? 0 : 1;
	};
	int lock(int sem_id, int target = 0)	//Z}tH̃bN
	{
		int ret;
		sembuffer.sem_num=target;
		sembuffer.sem_op = -1;
		ret = semop(sem_id,&sembuffer,1);
		if(ret==-1)//errorp
		{
			stringstream out;
			out << "Try lock " << sem_id << " but cannot.";
			string err(out.str());
			perror(err.c_str());
		}
		return ret;
	};
	int lock(int sem_id , double timeOutSec,int target =0)
	{
		int ret;
		struct timespec tms;
		sembuffer.sem_num=target;
		sembuffer.sem_op = -1;
		tms.tv_sec  = (short)timeOutSec; //sec
		tms.tv_nsec = (long)( (timeOutSec-(double)tms.tv_sec)*1000000000.0); //nano sec
 		ret = semtimedop(sem_id,&sembuffer,1,(const timespec*)&tms);
		if(ret==-1)//errorp
		{
			stringstream out;
			out << "while "<< tms.tv_sec<< "[sec]"<< tms.tv_nsec<< "[nano sec] Try lock " << sem_id << " but cannot.";
			string err(out.str());
			perror(err.c_str());
		}
	  return ret;
	};

	//Z}tH̃AbN
	int unlock(int sem_id , int target = 0) //̈悪P̏ꍇ
	{
		int ret;
		sembuffer.sem_num=target;
		sembuffer.sem_op = 1;
 		ret = semop(sem_id,&sembuffer,1);
 		if(ret ==-1){
			perror("Try unlock, but cannot");
		}
	  return ret;
	};
	int unlock(int sem_id , double timeOutSec,int target =0){
		int ret;
		struct timespec tms;
		sembuffer.sem_num=target;
		sembuffer.sem_op = 1;
		tms.tv_sec  = (int)timeOutSec; //sec
		tms.tv_nsec = (timeOutSec-(float)tms.tv_sec)/1000000000; //nano sec
 		ret = semtimedop(sem_id,&sembuffer,1,(const timespec*)tms);
 		if(ret ==-1){
			perror("Try unlock, but cannot(timeout)");
		}
	  return ret;
	};

	 SHARED_MEMORY_STRUCT* returnPointer(int id)
	{
		void *tmp;
		//Shared memoryɃA^b`
		tmp=reinterpret_cast<SHARED_MEMORY_STRUCT*>(shmat(id,(const void*)NULL,0));
		if(tmp == (void*)-1) sharedMemoryPointer = NULL;
		else sharedMemoryPointer=reinterpret_cast<SHARED_MEMORY_STRUCT*>(tmp);
		if(sharedMemoryPointer==NULL)
			std::cout << "Error:\x1b[33mId(" << id 
								<< ") has no shared memory.\x1b[39m" << std::endl;
		return sharedMemoryPointer;
	};
};

#endif

